# haverly.mod - Haverly's pooling problem

set X default 1..3;
set D default 1..2;

param d{D};
param q{D};
param r{D};
param c{X};
param pL := 1;
param pU := 5;

var x{X} >= 0, <= 300;
var y{D,D} >= 0, <= 200;
var p >= pL, <= pU;

maximize profit : sum{j in D} r[j] * (sum{i in D} y[i,j]) - 
                  sum{k in X} c[k] * x[k];

subject to mass_balance_pool : x[1] + x[2] = sum{j in D} y[1,j];
subject to mass_balance_C    : x[3] = sum{j in D} y[2,j];
subject to demand{j in D}    : sum{i in D} y[i,j] <= d[j];
subject to sulphur_balance   : 3*x[1] + x[2] = p * (sum{j in D} y[1,j]);
subject to quality{j in D}   : 
  p * y[1,j] + 2 * y[2,j] <= q[j] * sum{i in D} y[i,j];

